git-am.sh 10.0 KB
Newer Older
1 2
#!/bin/sh
#
3
# Copyright (c) 2005, 2006 Junio C Hamano
4

5 6
USAGE='[--signoff] [--dotest=<dir>] [--utf8] [--binary] [--3way]
  [--interactive] [--whitespace=<option>] <mbox>...
7 8
  or, when resuming [--skip | --resolved]'
. git-sh-setup
9

10 11
git var GIT_COMMITTER_IDENT >/dev/null || exit

12 13 14 15 16
stop_here () {
    echo "$1" >"$dotest/next"
    exit 1
}

17
stop_here_user_resolve () {
18 19 20 21
    if [ -n "$resolvemsg" ]; then
	    echo "$resolvemsg"
	    stop_here $1
    fi
22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40
    cmdline=$(basename $0)
    if test '' != "$interactive"
    then
        cmdline="$cmdline -i"
    fi
    if test '' != "$threeway"
    then
        cmdline="$cmdline -3"
    fi
    if test '.dotest' != "$dotest"
    then
        cmdline="$cmdline -d=$dotest"
    fi
    echo "When you have resolved this problem run \"$cmdline --resolved\"."
    echo "If you would prefer to skip this patch, instead run \"$cmdline --skip\"."

    stop_here $1
}

41 42 43 44 45 46 47 48 49 50 51 52 53 54
go_next () {
	rm -f "$dotest/$msgnum" "$dotest/msg" "$dotest/msg-clean" \
		"$dotest/patch" "$dotest/info"
	echo "$next" >"$dotest/next"
	this=$next
}

fall_back_3way () {
    O_OBJECT=`cd "$GIT_OBJECT_DIRECTORY" && pwd`

    rm -fr "$dotest"/patch-merge-*
    mkdir "$dotest/patch-merge-tmp-dir"

    # First see if the patch records the index info that we can use.
55
    if git-apply -z --index-info "$dotest/patch" \
56 57
	>"$dotest/patch-merge-index-info" 2>/dev/null &&
	GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
58
	git-update-index -z --index-info <"$dotest/patch-merge-index-info" &&
59 60 61
	GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
	git-write-tree >"$dotest/patch-merge-base+" &&
	# index has the base tree now.
J
Junio C Hamano 已提交
62 63
	GIT_INDEX_FILE="$dotest/patch-merge-tmp-index" \
	git-apply $binary --cached <"$dotest/patch"
64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83
    then
	echo Using index info to reconstruct a base tree...
	mv "$dotest/patch-merge-base+" "$dotest/patch-merge-base"
	mv "$dotest/patch-merge-tmp-index" "$dotest/patch-merge-index"
    fi

    test -f "$dotest/patch-merge-index" &&
    his_tree=$(GIT_INDEX_FILE="$dotest/patch-merge-index" git-write-tree) &&
    orig_tree=$(cat "$dotest/patch-merge-base") &&
    rm -fr "$dotest"/patch-merge-* || exit 1

    echo Falling back to patching base and 3-way merge...

    # This is not so wrong.  Depending on which base we picked,
    # orig_tree may be wildly different from ours, but his_tree
    # has the same set of wildly different changes in parts the
    # patch did not touch, so resolve ends up cancelling them,
    # saying that we reverted all those changes.

    git-merge-resolve $orig_tree -- HEAD $his_tree || {
84 85 86 87
	    if test -d "$GIT_DIR/rr-cache"
	    then
		git-rerere
	    fi
88 89 90 91 92 93
	    echo Failed to merge in the changes.
	    exit 1
    }
}

prec=4
94
dotest=.dotest sign= utf8= keep= skip= interactive= resolved= binary= ws= resolvemsg=
95 96 97 98 99 100 101 102 103 104 105 106 107 108

while case "$#" in 0) break;; esac
do
	case "$1" in
	-d=*|--d=*|--do=*|--dot=*|--dote=*|--dotes=*|--dotest=*)
	dotest=`expr "$1" : '-[^=]*=\(.*\)'`; shift ;;
	-d|--d|--do|--dot|--dote|--dotes|--dotest)
	case "$#" in 1) usage ;; esac; shift
	dotest="$1"; shift;;

	-i|--i|--in|--int|--inte|--inter|--intera|--interac|--interact|\
	--interacti|--interactiv|--interactive)
	interactive=t; shift ;;

109 110 111
	-b|--b|--bi|--bin|--bina|--binar|--binary)
	binary=t; shift ;;

112 113 114 115 116 117 118 119 120
	-3|--3|--3w|--3wa|--3way)
	threeway=t; shift ;;
	-s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
	sign=t; shift ;;
	-u|--u|--ut|--utf|--utf8)
	utf8=t; shift ;;
	-k|--k|--ke|--kee|--keep)
	keep=t; shift ;;

J
Junio C Hamano 已提交
121 122 123
	-r|--r|--re|--res|--reso|--resol|--resolv|--resolve|--resolved)
	resolved=t; shift ;;

124 125 126
	--sk|--ski|--skip)
	skip=t; shift ;;

J
Junio C Hamano 已提交
127 128 129
	--whitespace=*)
	ws=$1; shift ;;

130 131 132
	--resolvemsg=*)
	resolvemsg=$(echo "$1" | sed -e "s/^--resolvemsg=//"); shift ;;

133 134 135 136 137 138 139 140 141
	--)
	shift; break ;;
	-*)
	usage ;;
	*)
	break ;;
	esac
done

J
Junio C Hamano 已提交
142 143
# If the dotest directory exists, but we have finished applying all the
# patches in them, clear it out.
144 145 146 147 148 149 150 151 152 153 154 155 156
if test -d "$dotest" &&
   last=$(cat "$dotest/last") &&
   next=$(cat "$dotest/next") &&
   test $# != 0 &&
   test "$next" -gt "$last"
then
   rm -fr "$dotest"
fi

if test -d "$dotest"
then
	test ",$#," = ",0," ||
	die "previous dotest directory $dotest still exists but mbox given."
157
	resume=yes
158
else
J
Junio C Hamano 已提交
159 160
	# Make sure we are not given --skip nor --resolved
	test ",$skip,$resolved," = ,,, ||
161
		die "Resolve operation not in progress, we are not resuming."
162 163 164 165

	# Start afresh.
	mkdir -p "$dotest" || exit

166
	git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
167 168 169 170
		rm -fr "$dotest"
		exit 1
	}

J
Junio C Hamano 已提交
171 172
	# -b, -s, -u, -k and --whitespace flags are kept for the
	# resuming session after a patch failure.
J
Junio C Hamano 已提交
173
	# -3 and -i can and must be given when resuming.
174
	echo "$binary" >"$dotest/binary"
J
Junio C Hamano 已提交
175
	echo " $ws" >"$dotest/whitespace"
176 177 178 179 180 181
	echo "$sign" >"$dotest/sign"
	echo "$utf8" >"$dotest/utf8"
	echo "$keep" >"$dotest/keep"
	echo 1 >"$dotest/next"
fi

J
Junio C Hamano 已提交
182 183 184 185 186 187 188 189 190
case "$resolved" in
'')
	files=$(git-diff-index --cached --name-only HEAD) || exit
	if [ "$files" ]; then
	   echo "Dirty index: cannot apply patches (dirty: $files)" >&2
	   exit 1
	fi
esac

191 192 193 194
if test "$(cat "$dotest/binary")" = t
then
	binary=--allow-binary-replacement
fi
195 196 197 198 199 200 201 202
if test "$(cat "$dotest/utf8")" = t
then
	utf8=-u
fi
if test "$(cat "$dotest/keep")" = t
then
	keep=-k
fi
J
Junio C Hamano 已提交
203
ws=`cat "$dotest/whitespace"`
204 205 206 207 208 209 210 211 212 213 214 215 216 217 218
if test "$(cat "$dotest/sign")" = t
then
	SIGNOFF=`git-var GIT_COMMITTER_IDENT | sed -e '
			s/>.*/>/
			s/^/Signed-off-by: /'
		`
else
	SIGNOFF=
fi

last=`cat "$dotest/last"`
this=`cat "$dotest/next"`
if test "$skip" = t
then
	this=`expr "$this" + 1`
J
Jan Harkes 已提交
219
	resume=
220 221 222 223 224 225 226 227 228 229 230 231 232 233
fi

if test "$this" -gt "$last"
then
	echo Nothing to do.
	rm -fr "$dotest"
	exit
fi

while test "$this" -le "$last"
do
	msgnum=`printf "%0${prec}d" $this`
	next=`expr "$this" + 1`
	test -f "$dotest/$msgnum" || {
J
Jan Harkes 已提交
234
		resume=
235 236 237
		go_next
		continue
	}
J
Junio C Hamano 已提交
238 239 240 241 242 243 244 245 246

	# If we are not resuming, parse and extract the patch information
	# into separate files:
	#  - info records the authorship and title
	#  - msg is the rest of commit log message
	#  - patch is the patch body.
	#
	# When we are resuming, these files are either already prepared
	# by the user, or the user can tell us to do so by --resolved flag.
247 248 249 250 251 252 253 254
	case "$resume" in
	'')
		git-mailinfo $keep $utf8 "$dotest/msg" "$dotest/patch" \
			<"$dotest/$msgnum" >"$dotest/info" ||
			stop_here $this
		git-stripspace < "$dotest/msg" > "$dotest/msg-clean"
		;;
	esac
255 256 257 258

	GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
	GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
	GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
259 260 261 262 263 264 265

	if test -z "$GIT_AUTHOR_EMAIL"
	then
		echo "Patch does not have a valid e-mail address."
		stop_here $this
	fi

J
Junio C Hamano 已提交
266
	export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
267

268
	SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
269
	case "$keep_subject" in -k)  SUBJECT="[PATCH] $SUBJECT" ;; esac
270 271 272 273 274

	case "$resume" in
	'')
	    if test '' != "$SIGNOFF"
	    then
275
		LAST_SIGNED_OFF_BY=`
276 277 278
		    sed -ne '/^Signed-off-by: /p' \
		    "$dotest/msg-clean" |
		    tail -n 1
279
		`
280 281
		ADD_SIGNOFF=`
		    test "$LAST_SIGNED_OFF_BY" = "$SIGNOFF" || {
282 283
		    test '' = "$LAST_SIGNED_OFF_BY" && echo
		    echo "$SIGNOFF"
284 285
		}`
	    else
286
		ADD_SIGNOFF=
287 288
	    fi
	    {
289 290 291 292 293 294 295 296 297 298
		echo "$SUBJECT"
		if test -s "$dotest/msg-clean"
		then
			echo
			cat "$dotest/msg-clean"
		fi
		if test '' != "$ADD_SIGNOFF"
		then
			echo "$ADD_SIGNOFF"
		fi
299 300
	    } >"$dotest/final-commit"
	    ;;
J
Junio C Hamano 已提交
301
	*)
302
		case "$resolved$interactive" in
J
Junio C Hamano 已提交
303 304 305 306 307
		tt)
			# This is used only for interactive view option.
			git-diff-index -p --cached HEAD >"$dotest/patch"
			;;
		esac
308
	esac
309

310
	resume=
311 312
	if test "$interactive" = t
	then
313 314
	    test -t 0 ||
	    die "cannot be interactive without stdin connected to a terminal."
315 316 317 318 319 320 321
	    action=again
	    while test "$action" = again
	    do
		echo "Commit Body is:"
		echo "--------------------------"
		cat "$dotest/final-commit"
		echo "--------------------------"
J
Jason Riedy 已提交
322
		printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
323 324
		read reply
		case "$reply" in
325 326 327 328
		[yY]*) action=yes ;;
		[aA]*) action=yes interactive= ;;
		[nN]*) action=skip ;;
		[eE]*) "${VISUAL:-${EDITOR:-vi}}" "$dotest/final-commit"
329
		       action=again ;;
330 331 332
		[vV]*) action=again
		       LESS=-S ${PAGER:-less} "$dotest/patch" ;;
		*)     action=again ;;
333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354
		esac
	    done
	else
	    action=yes
	fi

	if test $action = skip
	then
		go_next
		continue
	fi

	if test -x "$GIT_DIR"/hooks/applypatch-msg
	then
		"$GIT_DIR"/hooks/applypatch-msg "$dotest/final-commit" ||
		stop_here $this
	fi

	echo
	echo "Applying '$SUBJECT'"
	echo

J
Junio C Hamano 已提交
355 356
	case "$resolved" in
	'')
J
Junio C Hamano 已提交
357
		git-apply $binary --index $ws "$dotest/patch"
J
Junio C Hamano 已提交
358 359 360 361 362 363 364 365
		apply_status=$?
		;;
	t)
		# Resolved means the user did all the hard work, and
		# we do not have to do any patch application.  Just
		# trust what the user has in the index file and the
		# working tree.
		resolved=
366 367 368 369
		changed="$(git-diff-index --cached --name-only HEAD)"
		if test '' = "$changed"
		then
			echo "No changes - did you forget update-index?"
370
			stop_here_user_resolve $this
371
		fi
372 373 374 375 376
		unmerged=$(git-ls-files -u)
		if test -n "$unmerged"
		then
			echo "You still have unmerged paths in your index"
			echo "did you forget update-index?"
377
			stop_here_user_resolve $this
378
		fi
J
Junio C Hamano 已提交
379 380 381 382
		apply_status=0
		;;
	esac

383 384
	if test $apply_status = 1 && test "$threeway" = t
	then
385
		if (fall_back_3way)
386
		then
387 388
		    # Applying the patch to an earlier tree and merging the
		    # result may have produced the same tree as ours.
389
		    changed="$(git-diff-index --cached --name-only HEAD)"
390 391 392 393 394 395 396 397
		    if test '' = "$changed"
		    then
			    echo No changes -- Patch already applied.
			    go_next
			    continue
		    fi
		    # clear apply_status -- we have successfully merged.
		    apply_status=0
398 399 400 401 402
		fi
	fi
	if test $apply_status != 0
	then
		echo Patch failed at $msgnum.
403
		stop_here_user_resolve $this
404 405 406 407 408 409 410 411 412 413 414 415
	fi

	if test -x "$GIT_DIR"/hooks/pre-applypatch
	then
		"$GIT_DIR"/hooks/pre-applypatch || stop_here $this
	fi

	tree=$(git-write-tree) &&
	echo Wrote tree $tree &&
	parent=$(git-rev-parse --verify HEAD) &&
	commit=$(git-commit-tree $tree -p $parent <"$dotest/final-commit") &&
	echo Committed: $commit &&
416
	git-update-ref -m "am: $SUBJECT" HEAD $commit $parent ||
417 418 419 420 421 422 423 424 425 426 427
	stop_here $this

	if test -x "$GIT_DIR"/hooks/post-applypatch
	then
		"$GIT_DIR"/hooks/post-applypatch
	fi

	go_next
done

rm -fr "$dotest"